<?php

namespace patest\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CrmSyncEntitySubObject StructType
 * @subpackage Structs
 */
class CrmSyncEntitySubObject extends CrmSyncEntitySync_IntegrationBase
{
    /**
     * The ParentExternalId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ParentExternalId;
    /**
     * Constructor method for CrmSyncEntitySubObject
     * @uses CrmSyncEntitySubObject::setParentExternalId()
     * @param string $parentExternalId
     */
    public function __construct($parentExternalId = null)
    {
        $this
            ->setParentExternalId($parentExternalId);
    }
    /**
     * Get ParentExternalId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getParentExternalId()
    {
        return isset($this->ParentExternalId) ? $this->ParentExternalId : null;
    }
    /**
     * Set ParentExternalId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $parentExternalId
     * @return \patest\StructType\CrmSyncEntitySubObject
     */
    public function setParentExternalId($parentExternalId = null)
    {
        // validation for constraint: string
        if (!is_null($parentExternalId) && !is_string($parentExternalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($parentExternalId, true), gettype($parentExternalId)), __LINE__);
        }
        if (is_null($parentExternalId) || (is_array($parentExternalId) && empty($parentExternalId))) {
            unset($this->ParentExternalId);
        } else {
            $this->ParentExternalId = $parentExternalId;
        }
        return $this;
    }
}
